#
#
#  Provides Netstat summart for Introscope
#
#

$base='AIX|Netstat';

$listenports = {};
$stateCnt = {};

$stateCnt{'CLOSE_WAIT'}=0;
$stateCnt{'ESTABLISHED'}=0;
$stateCnt{'FIN_WAIT_1'}=0;
$stateCnt{'FIN_WAIT_2'}=0;
$stateCnt{'LAST_ACK'}=0;
$stateCnt{'LISTEN'}=0;
$stateCnt{'SYN_RCVD'}=0;
$stateCnt{'SYN_SENT'}=0;
$stateCnt{'TIME_WAIT'}=0;

@lines = `netstat -na`;


if(@lines) {
   foreach $line (@lines) {
        #print "$line\n";
        @cols = split(/\s+/,$line);

        $proto = $cols[0];
        $froma = $cols[3];
        $toa = $cols[4];
        $state = $cols[5];

        if ( $proto =~ /tcp/ ) {

            if ( exists $stateCnt{$state})  {
               $stateCnt{$state} = $stateCnt{$state} + 1;
            }
            else {
               $stateCnt{$state} = 1;
            }

            if ( $state =~ "LISTEN" ) {
               #print "$froma\n";
               if ( $froma =~ /\*\.(.*)/ ) {
                  #print "lisetn on $1\n";
                  $listenports{$1} = 0;
               } 

            }
        }
   }

    while ( my ($key, $value) = each(%stateCnt) ) {
        print "<metric type=\"IntCounter\"  name=\"$base|state:$key\" value=\"$value\"/>\n"
    }

   foreach $line (@lines) {
        #print "$line\n";
        @cols = split(/\s+/,$line);

        $proto = $cols[0];
        $froma = $cols[3];
        $toa = $cols[4];
        $state = $cols[5];

        if ( $proto =~ /tcp/ ) {

            if ( !($state =~ "LISTEN") ) {

               
               if ( $froma =~ /[\d]+\.[\d]+\.[\d]+\.[\d]+\.(.*)/ ) {
                    #print "connect to $1\n";
                    if ( exists $listenports{$1} ) {
                        #print "INCOMING\n";
                        $listenports{$1} = $listenports{$1} + 1
                    }
                    #else {
                       # add outbound counts
                    #}
               } 




            } 
        }
   }

    while ( my ($key, $value) = each(%listenports) ) {
        #print "$key => $value\n";
        print "<metric type=\"IntCounter\"  name=\"$base|listener:$key\" value=\"$value\"/>\n"
    }

}

